#ifndef GNUPLOT2D_HH
#define GNUPLOT2D_HH

#include <cstdio>
#include "Math.hh"
#include "Vector.hh"

typedef enum {X11, LATEX, POSTSCRIPT} Terminal;
typedef enum {LINES, POINTS, LINESPOINTS, DOTS} PlotStyle;

class Gnuplot2d {
public:
  Gnuplot2d();
  void setTerminal(Terminal term, const char* fileName = 0);
  void setStyle(PlotStyle sty);
  void setTitle(const char* str);
  void setXLabel(const char* str);
  void setYLabel(const char* str);
  void setXRange(double min, double max);
  void setYRange(double min, double max);
  void setGrid(Boolean b);
  void plot(const Vector& x,  const Vector& y); 
  void plot(const Vector& x,  const Vector& y,  const Vector& error);
  void plot(const Vector& x0, const Vector& y0, const Vector& x1, const Vector& y1);
  void message(const char* msg);
  ~Gnuplot2d();

private:
  FILE* fp;
};

#endif
