#ifndef MATH_HH
#define MATH_HH

typedef enum {FALSE, TRUE} Boolean;

//
// This abstract class contains useful
// mathematical methods and constants.
//
class Math {
public:

  // Return the minimum of a and b.
  static double min(double a, double b);

  // Return the maximum of a and b.
  static double max(double a, double b);

  // Return the absolute value of d.
  static double abs(double d);

  // Return d squared.
  static double sqr(double d);

  // Return the constant pi.
  static double pi();

  // Return exp(x), bounds are placed on the exponential function.
  static double safeExp(double x);

private:
  virtual dummy() = 0; // make this class abstract
};

// include inline methods
#include "Math.icc"
#endif
