#ifndef MATRIX_HH
#define MATRIX_HH

#include <iostream.h>
#include "Vector.hh"
#include "SymmetricMatrix.hh"

class Matrix {
public:
  Matrix(int row, int col);
  Matrix(const Matrix& matrix);
  Matrix(const SymmetricMatrix& matrix);

  Matrix& operator=(const Matrix& matrix);
  Matrix& operator=(double value);

  Vector row(int i) const;
  Vector col(int j) const;

  const Vector& operator[](int i) const;
  Vector& operator[](int i);
  Vector operator*(const Vector& vector) const;

  int getRows() const;
  int getCols() const;

  void row(int i, const Vector& vector);
  void col(int j, const Vector& vector);

  virtual ~Matrix();

  friend ostream& operator<<(ostream& oStream, const Matrix& matrix);
  friend istream& operator>>(istream& iStream, Matrix& matrix);

private:
  int rows;       // rows matrix has
  int cols;       // columns matrix has
  Vector* vecPtr; // matrix is an array of vectors
};

#endif
