#ifndef POSTERIOR_HH
#define POSTERIOR_HH

#include "Vector.hh"
#include "Covariance.hh"

class MinusLogLike {
public:
  MinusLogLike(Covariance& c, const Vector& t);
  double minusLogLike(const Vector& theta);
  virtual ~MinusLogLike();

private:
  Covariance& cov;
  const Vector& targets;
};

class IAMinusLogLike {
public:
  IAMinusLogLike(Covariance& c, const Vector& t);
  double minusLogLike(const Vector& theta);
  virtual ~IAMinusLogLike();

private:
  Covariance& cov;
  const Vector& targets;
};

class MinusLogPrior {
public:
  MinusLogPrior();
  double minusLogPrior(const Vector& theta);
  virtual ~MinusLogPrior();
};

#endif
