#ifndef RANDOM_HH
#define RANDOM_HH

#include "Vector.hh"

class Random {
public:
  Random(long seed);
  double uniform();
  double uniopen();
  double normal();
  double gamma(int v);
  double beta(int v1, int v2);
  void randSphere(Vector& v);
  void cauchy(Vector& v);
  void setSeed(long seed);
  long rand();
  virtual ~Random();

private:
  class Random16 {
  public:
    Random16(int length, long mm, long aa, long cc, long ss);
    long rand();
    ~Random16();

  private:
    int table_size;
    long m, a, c, seed, randout;
    long* table;
  };

  void init(long seed);
  int table_size;
  long randout;
  long* table;
  Random16* rand1;
  Random16* rand2;
};

#endif
