#ifndef VECTOR_HH
#define VECTOR_HH

#include <iostream.h>

class Vector {
public:
  Vector(int length = 0);
  Vector(int length, double init);
  Vector(const Vector& vector);

  Vector operator+(const Vector& vector) const;
  Vector operator-(const Vector& vector) const;
  Vector operator*(const Vector& vector) const;
  Vector operator/(const Vector& vector) const;

  Vector& operator=(const Vector& vector);
  Vector& operator=(double value);

  Vector slice(int a, int length) const;

  Vector& operator+=(double d);
  Vector& operator-=(double d);
  Vector& operator*=(double d);
  Vector& operator/=(double d);

  double operator[](int i) const;
  double& operator[](int i);

  double dotProduct(const Vector& vector) const;
  double squaredNorm(const Vector& vector) const;
  double squaredNorm(const Vector& vector, const Vector& weights) const;

  int getSize() const;

  void resize(int length);

  virtual ~Vector();

  friend ostream& operator<<(ostream& oStream, const Vector& vector);
  friend istream& operator>>(istream& iStream, Vector& vector);

private:
  int size;       // size of vector
  double* dblPtr; // vector is an array of doubles
};

#endif
